<?

$block = new JabatoBlock;

$newProgramId = 1;
$newMusicBlockId = 1000;


class JabatoBlock {
  var $id="";
  var $name="";
  var $songsperslot="";
  var $shuffle="";
  var $jabatos="";
  var $email="";
  var $href="";
  var $fgimg="";
  var $bkimg="";
  var $description="";
  var $programfile="";
  var $programtolan="";
  var $programtowan="";
  var $slotsdirs="";
  var $textsdirs="";
  var $songsdirs="";

  var $selectblocks=array();

  var $f;

  var $removing=false;

  function loadFromJBF() {
  global $JBFFILE;

    $this->description = "";
    $this->slotsdirs = "";
    $this->textsdirs = "";
    $this->songsdirs = "";
 		
    $xml_parser = xml_parser_create();
    xml_set_element_handler($xml_parser, "loadBlkStartElement", "loadBlkEndElement");
    xml_set_character_data_handler($xml_parser, "loadBlkCharacterData");
 		
    if (!($fp = fopen($JBFFILE, "r"))) {
      die("could not open XML input");
    }

    while ($data = fread($fp, 4096)) {
      if (!xml_parse($xml_parser, $data, feof($fp))) {
        die(sprintf("XML error: %s at line %d",
            xml_error_string(xml_get_error_code($xml_parser)),
            xml_get_current_line_number($xml_parser)));
      }
    }
    xml_parser_free($xml_parser);
  }

  function loadFromGlobals() {
    global $blockId;
    global $name;
    global $songsperslot;
    global $shuffle;
    global $jabatos;
    global $email;
    global $href;
    global $fgimg;
    global $bkimg;
    global $description;
    global $programfile;
    global $programtolan;
    global $programtowan;
    global $slotsdirs;
    global $textsdirs;
    global $songsdirs;

    $this->id = $blockId;
    $this->name = $name;
    $this->songsperslot = $songsperslot;
    $this->shuffle = $shuffle;
    $this->jabatos = $jabatos;
    $this->email = $email;
    $this->href = $href;
    $this->fgimg = $fgimg;
    $this->bkimg = $bkimg;
    $this->description = $description;
    $this->programfile = $programfile;
    $this->programtolan = $programtolan;
    $this->programtowan = $programtowan;
    $this->slotsdirs = $slotsdirs;
    $this->textsdirs = $textsdirs;
    $this->songsdirs = $songsdirs;
  }


  function updateJBF()	{
  global $JBFFILE;
  global $VARLIBDIR;
    
    if($this->f = fopen($JBFFILE.".tmp","w")) {
      $xml_parser = xml_parser_create();
      xml_set_element_handler($xml_parser, 
                              "updateBlkStartElement", 
			      "updateBlkEndElement");
      xml_set_character_data_handler($xml_parser, 
                              "updateBlkCharacterData");
      if (!($fp = fopen($JBFFILE, "r")))
        return false;
 			
      while ($data = fread($fp, 4096)) {
     	if (!xml_parse($xml_parser, $data, feof($fp)))
  	  return false;
      }
      xml_parser_free($xml_parser);
      fclose($this->f);
      $fecha=date("Ymd");
      rename($JBFFILE,"$fecha.jBF");
      rename($JBFFILE.".tmp",$JBFFILE);
      error_log(strftime("%d/%m/%Y\t%H:%M\t",time()).$this->id."\t".$this->name."\n",3,$VARLIBDIR."/blocksupdated.log");
      return true;
    }
    else
      return false;
  }


  function addBlockToJBF()	{
  global $JBFFILE;
  global $VARLIBDIR;

    if($this->f = fopen($JBFFILE.".tmp","w")) {
      $xml_parser = xml_parser_create();
      xml_set_element_handler($xml_parser, 
                              "addBlkStartElement", 
			      "addBlkEndElement");
      xml_set_character_data_handler($xml_parser, "addBlkCharacterData");
 		
      if (!($fp = fopen($JBFFILE, "r")))
        return false;
 			
      while ($data = fread($fp, 4096)) {
     	if (!xml_parse($xml_parser, $data, feof($fp)))
  	  return false;
      }
      xml_parser_free($xml_parser);
      fclose($this->f);
      rename($JBFFILE,$JBFFILE.".bak");
      rename($JBFFILE.".tmp",$JBFFILE);
      error_log(strftime("%d/%m/%Y\t%H:%M\t",
                         time()).$this->id."\t".$this->name."\n",
                         3,$VARLIBDIR."/blocksadded.log");
      return true;
    }
    else
      return false;
  }
	
  function removeBlockFromJBF()	{
    if(!empty($this->name)) {
      $this->removing=true;
      return $this->updateJBF();
    }
    else
      return false;
  }
	
  function writeBlock() {
   if(!$this->removing) {
    fputs($this->f,
          "<BLOCK ID=\"".$this->id."\" NAME=\"".
	  translateEntities(normalize($this->name))."\" ");
    if(!empty($this->songsperslot))
      fputs($this->f,"SONGSPERSLOT=\"".$this->songsperslot."\" ");
    if(!empty($this->shuffle))
      fputs($this->f,"SHUFFLE=\"".$this->shuffle."\" ");
    if(!empty($this->jabatos))
      fputs($this->f,"JABATOS=\"".translateEntities(normalize($this->jabatos))."\" ");
    if(!empty($this->email))
      fputs($this->f,"EMAIL=\"".$this->email."\" ");
    if(!empty($this->href))
      fputs($this->f,"HREF=\"".$this->href."\" ");
    if(!empty($this->fgimg))
      fputs($this->f,"IMG=\"".$this->fgimg."\" ");
    if(!empty($this->bkimg))
      fputs($this->f,"BKIMG=\"".$this->bkimg."\" ");
    fputs($this->f,">");
    if(!empty($this->programfile))
      fputs($this->f,"\n<PROGRAMFILE PATH=\"".$this->programfile."\" ");
    if(!empty($this->programtolan))
      fputs($this->f,"TOLANDISKCMD=\"".$this->programtolan."\" ");
    if(!empty($this->programtowan))
      fputs($this->f,"TOWANDISKCMD=\"".$this->programtowan."\" ");
    if(!empty($this->programfile))
      fputs($this->f,"/>");
    if(!empty($this->slotsdirs)) {
      $dirs = explode("*",$this->slotsdirs);
      for($i=0; $i<count($dirs);$i++) {
        if (!empty($dirs[$i]))
          fputs($this->f,"\n<SLOTSDIRECTORY PATH=\"".$dirs[$i]."\"/>");
      }
    }
		
    if(!empty($this->textsdirs)) {
      $dirs = explode("*",$this->textsdirs);
      for($i=0; $i<count($dirs);$i++) {
        if (!empty($dirs[$i]))
          fputs($this->f,"\n<TEXTSDIRECTORY PATH=\"".$dirs[$i]."\"/>");
      }
    }
		
    if(!empty($this->songsdirs)) {
      $dirs = explode("*",$this->songsdirs);
      for($i=0; $i<count($dirs);$i++) {
        if (!empty($dirs[$i]))
          fputs($this->f,"\n<SONGSDIRECTORY PATH=\"".$dirs[$i]."\"/>");
      }
    }
    
    if(!empty($this->description))
      fputs($this->f,translateEntities($this->description));
      
    fputs($this->f,"\n</BLOCK>\n");
   }
  }

  function addDir($ofwhat,$dir) {
    $this->{$ofwhat}.=$dir."*";
  }

  function removeDir($ofwhat,$dir) {
    $this->{$ofwhat}= substr_replace($this->{$ofwhat},"",
	                             strpos($this->{$ofwhat},$dir),
			             strlen($dir)+1);
  }
  
  function writeTranslatedString($str) {
		fputs($this->f,
		      str_replace(">","&gt;",
		        str_replace("<","&lt;",
		          str_replace("&","&amp;",$str))));
  }

  function writeString($str) {
		fputs($this->f,$str);
  }


  function echoHTMLCheckboxes($ofwhat,$nameprefix) {
    global $block;
    $dirs=explode("*",$block->{$ofwhat}); 
    for($i=0; $i<count($dirs);$i++) {
      if (!empty($dirs[$i]))
        echo "<input type='checkbox' name='$nameprefix".$dirs[$i]."'/>\n";
        echo $dirs[$i]."<br>\n";
    }
  }

  function echoHTMLHiddenFields() {
    global $block;
?>
  <input type=hidden name=name value="<? echo $block->name ?>">
  <input type=hidden name=jabatos 
           value="<? echo str_replace('"','\"',$block->jabatos) ?>">
  <input type=hidden name=email value="<? echo $block->email ?>">
  <input type=hidden name=href value="<? echo $block->href ?>">
  <input type=hidden name=descripcion 
           value="<? echo str_replace('"','\"',$block->description) ?>">
  
  <input type=hidden name=fgimg value="<? echo $block->fgimg ?>">
  <input type=hidden name=bkimg value="<? echo $block->bkimg ?>">

  <input type=hidden name=programfile 
            value="<? echo $block->programfile ?>">
  <input type=hidden name=programtolan 
            value="<? echo $block->programtolan ?>">
  <input type=hidden name=programtowan 
            value="<? echo $block->programtowan ?>">
  <input type=hidden name=songsdirs 
            value="<? echo $block->songsdirs ?>">
  <input type=hidden name=slotsdirs 
            value="<? echo $block->slotsdirs ?>">
  <input type=hidden name=textsdirs 
            value="<? echo $block->textsdirs ?>">
  <input type=hidden name=songsperslot 
            value="<? echo $block->songsperslot ?>">
  <input type=hidden name=shuffle 
            value="<? echo $block->shuffle ?>">
  <input type=hidden name=blockId value="<? echo $block->id ?>">
<?
  }

  function echoHTMLForm()
  {
    global $UPDATEBLOCKPAGE;
    global $block;
?>
  <font size=+2><b><?echo $block->name?></b></font><br>
<form action=<? echo $UPDATEBLOCKPAGE ?> method=POST>
  <b><U>DATOS P&Aacute;GINA WEB</U></B><BR>
  CULPABLE/S&nbsp;&nbsp;<input name=jabatos value="<? echo $block->jabatos ?>" size=50><br>
  CORREO ELECTR&Oacute;NICO&nbsp;&nbsp;<input name=email value="<? echo $block->email ?>" size=40><br>
  P&Aacute;GINA WEB&nbsp;&nbsp;<input name=href value="<? echo $block->href ?>" size=40><br><br>
  DESCRIPCI&Oacute;N<br>
  <textarea name=description cols=60 rows=10 wrap=soft><? echo $block->description; ?></textarea><br>
  IMAGEN PRINCIPAL&nbsp;&nbsp;<input name=fgimg value="<? echo $block->fgimg ?>" size=20><br>
  IMAGEN DE FONDO&nbsp;&nbsp;<input name=bkimg value="<? echo $block->bkimg ?>" size=20><br>
  <br>
  <center>
  <hr>
  <input type=submit value="PINCHA AQU&Iacute; PARA ACTUALIZAR LOS DATOS">
  <hr>
  <b><U>DATOS CONTINUIDAD</U></B><br>(solo para usuarios expertos)</center><BR>
  FICHERO MP3&nbsp;&nbsp;<input name=programfile value="<? echo $block->programfile ?>" size=50><br>
  &nbsp;&nbsp;- COMANDO PARA COPIA LOCAL&nbsp;&nbsp;
  <input name=programtolan value="<? echo $block->programtolan ?>" size=20><br>
  &nbsp;&nbsp;- COMANDO PARA COPIA REMOTA&nbsp;&nbsp;
  <input name=programtowan value="<? echo $block->programtowan ?>" size=20><br>
  DIRECTORIO(S) M&Uacute;SICA&nbsp;&nbsp;
  <input name=songsdirs value="<? echo $block->songsdirs ?>" size=50><br>
  DIRECTORIO(S) CU&Ntilde;AS&nbsp;&nbsp;
  <input name=slotsdirs value="<? echo $block->slotsdirs ?>" size=50><br>
  DIRECTORIO(S) TEXTOS&nbsp;&nbsp;
  <input name=textsdirs value="<? echo $block->textsdirs ?>" size=50><br>
  CANCIONES POR CU&Ntilde;A/TEXTO&nbsp;&nbsp;
  <input name=songsperslot value="<? echo $block->songsperslot ?>" ><br>
  TIPO ALEATORIEDAD&nbsp;&nbsp;
  <select name=shuffle>
    <option value="0" <? echo ($block->shuffle==0?"selected":"") ?> >
    TODO SECUENCIAL (POR ORDEN ALFABETICO)
    <option value="1" <? echo ($block->shuffle==1?"selected":"") ?> >
    M&Uacute;SICA ALEATORIA
    <option value="2" <? echo ($block->shuffle==2?"selected":"") ?> >
    CU&Ntilde;AS ALETORIAS
    <option value="3" <? echo ($block->shuffle==3?"selected":"") ?> >
    M&Uacute;SICA Y CU&Ntilde;AS ALEATORIAS
    <option value="4" <? echo ($block->shuffle==4?"selected":"") ?> >
    TEXTOS ALEATORIOS
    <option value="5" <? echo ($block->shuffle==5?"selected":"") ?> >
    TEXTOS Y M&Uacute;SICA ALEATORIOS
    <option value="6" <? echo ($block->shuffle==6?"selected":"") ?> >
    TEXTOS Y CU&Ntilde;AS ALEATORIAS
    <option value="7" <? echo ($block->shuffle==7?"selected":"") ?> >
    TODO ALEATORIO
  </select>
  
  <input type=hidden name=blockId value="<? echo $block->id ?>"><br><br>
  <input type=hidden name=name value="<? echo $block->name ?>">
</form>
<?
	}

	function echoHTMLSelect($nombre_select)
	{
		echo "<SELECT NAME=\"$nombre_select\">\n";
		
		ksort($this->selectblocks);
		$ids = array_keys($this->selectblocks);
		for($i=0;$i<count($this->selectblocks);$i++) {
			if($this->selectblocks[$ids[$i]]!=-1) {
				echo "\t<OPTION VALUE=".$this->selectblocks[$ids[$i]]." ";
				if($this->id==$this->selectblocks[$ids[$i]])
				  echo "SELECTED";
				echo "> ".$ids[$i]."</OPTION>\n";
			}
		}
		echo "\n</SELECT>";
	}

	function echoProgramsHTMLSelect($nombre_select,$first_option="")
	{
		echo "<SELECT NAME=\"$nombre_select\">\n";
		
		if($first_option!="")
			echo "\t<OPTION VALUE=\"0\">$first_option</OPTION>\n";

		ksort($this->selectblocks);
		$ids = array_keys($this->selectblocks);
		for($i=0;$i<count($this->selectblocks);$i++) {
			if(($this->selectblocks[$ids[$i]]!=0) && ($this->selectblocks[$ids[$i]]<1000)) {
				echo "\t<OPTION VALUE=".$this->selectblocks[$ids[$i]]." ";
				if($this->id==$this->selectblocks[$ids[$i]])
				  echo "SELECTED";
				echo "> ".$ids[$i]."</OPTION>\n";
			}
		}
		echo "\n</SELECT>";
	}

}


function translateEntities($str) {
  return str_replace("<","&lt;",
         str_replace(">","&gt;",
         str_replace("&amp;amp;","&amp;",
           (nl2br(str_replace("&","&amp;",htmlentities($str)))))));
//           (nl2br(str_replace("&","&amp;",$str)))));
}

function untranslateEntities($str) {
  return $str;
  
//  return 
   //str_replace("&lt;","<",
//         str_replace("&gt;",">",
 //        str_replace("&amp;","&",$str);
//	 str_replace("didddd","kk&",$str))));
}

$inOurBlock = false;

function loadBlkStartElement($parser, $name, $attrs) {
  global $block;
  global $inOurBlock;

  if($inOurBlock) {
    if($name=="PROGRAMFILE") {
			$block->programfile = $attrs["PATH"];
			$block->programtolan = $attrs["TOLANDISKCMD"];
			$block->programtowan = $attrs["TOWANDISKCMD"];
    }
    else if($name=="SLOTSDIRECTORY") {
			$block->slotsdirs .= $attrs["PATH"]."*";
    }
    else if($name=="TEXTSDIRECTORY") {
			$block->textsdirs .= $attrs["PATH"]."*";
    }
    else if($name=="SONGSDIRECTORY") {
			$block->songsdirs .= $attrs["PATH"]."*";
    }
  }
  else if($name=="BLOCK") {
  				//&&
          //((int)$attrs["ID"] > 0) &&
          //((int)$attrs["ID"] < 1000))
    global $newProgramId;
    global $newMusicBlockId;
    if ($attrs["ID"]<1000)
      $newProgramId= $attrs["ID"] + 1;
    else
      $newMusicBlockId= $attrs["ID"] + 1;

		if ($attrs["ID"] == $block->id) {
			$block->name = untranslateEntities($attrs["NAME"]);
			$block->songsperslot = $attrs["SONGSPERSLOT"];
			$block->shuffle = $attrs["SHUFFLE"];
			$block->jabatos = untranslateEntities($attrs["JABATOS"]);
			$block->email = $attrs["EMAIL"];
			$block->href = $attrs["HREF"];
			$block->fgimg = $attrs["IMG"];
			$block->bkimg = $attrs["BKIMG"];
			$inOurBlock = true;
		}
		$block->selectblocks[$attrs["NAME"]] = $attrs["ID"];
  }
}


function loadBlkEndElement($parser, $name) {
  global $inOurBlock;
  if($inOurBlock && ($name=="BLOCK")) {
    global $block;
    $inOurBlock = false;
    $block->description = str_replace("<br>","\n",$block->description);
    $block->description = str_replace("<BR>","\n",$block->description);
  }
}

function loadBlkCharacterData($parser, $data) {
  global $inOurBlock;
  if($inOurBlock) {
    global $block;
    $block->description .= chop(untranslateEntities($data));
  }
}


$blockAdded = false;

function addBlkStartElement($parser, $name, $attrs) {
  global $block;
  global $blockAdded;

  if($name=="BLOCK") {
  	if (($attrs["ID"] == $block->id) && (!$blockAdded)) {
		  $block->writeBlock();
		  $blockAdded = true;
  	}
  	else {
	  	if (($attrs["ID"] > $block->id) && (!$blockAdded)) {
			  $block->writeBlock();
			  $blockAdded = true;
	  	}
    	$block->writeString("<BLOCK ");
    	for(reset($attrs);$ind=key($attrs);next($attrs))
 	     	$block->writeTranslatedString($ind."=\"".$attrs[$ind]."\" ");
    	$block->writeString(">");
    }
	}
	else {
//	  if(!$blockAdded) {
		  $block->writeString("<".$name." ");
	    for(reset($attrs);$ind=key($attrs);next($attrs))
  	    $block->writeTranslatedString($ind."=\"".$attrs[$ind]."\" ");
	  	if($name=="JABATOBLOCKFILE")
	    	$block->writeString(">");
		  else
		    $block->writeString("/>");
//		}
	}
}


function addBlkEndElement($parser, $name) {
  global $blockAdded;
  global $block;
  if($name=="BLOCK") { //&& (!$blockAdded)) {
    $block->writeString("</BLOCK>");
  }
  else if($name=="JABATOBLOCKFILE") {
		if(!$blockAdded) {
		  $block->writeBlock();
		  $blockAdded = true;
		}
    $block->writeString("</JABATOBLOCKFILE>");
  }
}


function addBlkCharacterData($parser, $data) {
  global $block;
  global $blockAdded;

//  if(!$blockAdded)
    $block->writeTranslatedString($data);
}


function normalize($str) {
  return str_replace("","a",
         str_replace("","e",
         str_replace("","i",
         str_replace("","o",
         str_replace("","u",
         str_replace("","u",
	 str_replace("","A",
         str_replace("","E",
         str_replace("","I",
         str_replace("","O",
         str_replace("","U",
         str_replace("","U",
         str_replace("&","Y",
         str_replace("","N",
         str_replace("","n",$str)))))))))))))));
}



function updateBlkStartElement($parser, $name, $attrs) {
  global $block;
  global $inOurBlock;

  if(!$inOurBlock) {
    if($name=="BLOCK") {
  		if ($attrs["ID"] == $block->id) {
  			$inOurBlock = true;
  			$block->writeBlock();
  		}
  		else {
		    $block->writeString("<BLOCK ");
		    for(reset($attrs);$ind=key($attrs);next($attrs))
		      $block->writeTranslatedString($ind."=\"".$attrs[$ind]."\" ");
		    $block->writeString(">");
		  }
		}
		else {
		  $block->writeString("<".$name." ");
	    for(reset($attrs);$ind=key($attrs);next($attrs))
	      $block->writeTranslatedString($ind."=\"".$attrs[$ind]."\" ");
		  if($name=="JABATOBLOCKFILE")
		    $block->writeString(">");
		  else
		    $block->writeString("/>");
		}
  }
}


function updateBlkEndElement($parser, $name) {
  global $inOurBlock;
  global $block;
  if($name=="BLOCK") {
    if($inOurBlock)
      $inOurBlock = false;
    else
	    $block->writeString("</BLOCK>");
  }
  else if (!$inOurBlock) {
	  if($name=="JABATOBLOCKFILE")
	    $block->writeString("</JABATOBLOCKFILE>");
  }
}

function updateBlkCharacterData($parser, $data) {
  global $inOurBlock;
  if(!$inOurBlock) {
    global $block;
    $block->writeTranslatedString($data);
  }
}

?>

